<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAdvancedWifiStatsForVideoDeviceOutput StructType
 * @subpackage Structs
 */
class GetAdvancedWifiStatsForVideoDeviceOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The Stats
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \CustomerManagement\StructType\AdvancedStats
     */
    public $Stats;
    /**
     * Constructor method for GetAdvancedWifiStatsForVideoDeviceOutput
     * @uses GetAdvancedWifiStatsForVideoDeviceOutput::setSuccess()
     * @uses GetAdvancedWifiStatsForVideoDeviceOutput::setErrorMessage()
     * @uses GetAdvancedWifiStatsForVideoDeviceOutput::setStats()
     * @param bool $success
     * @param string $errorMessage
     * @param \CustomerManagement\StructType\AdvancedStats $stats
     */
    public function __construct($success = null, $errorMessage = null, \CustomerManagement\StructType\AdvancedStats $stats = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessage($errorMessage)
            ->setStats($stats);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\GetAdvancedWifiStatsForVideoDeviceOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\GetAdvancedWifiStatsForVideoDeviceOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get Stats value
     * @return \CustomerManagement\StructType\AdvancedStats|null
     */
    public function getStats()
    {
        return $this->Stats;
    }
    /**
     * Set Stats value
     * @param \CustomerManagement\StructType\AdvancedStats $stats
     * @return \CustomerManagement\StructType\GetAdvancedWifiStatsForVideoDeviceOutput
     */
    public function setStats(\CustomerManagement\StructType\AdvancedStats $stats = null)
    {
        $this->Stats = $stats;
        return $this;
    }
}
